---

Quantum mechanics isn't too different from a random black box, since it induces random measurement outcomes:

<img src="pics/quantum.svg" width="450px">

However, there are some peculiar differences between classical and
quantum randomness. To explore these, we'll use an example where we can not only change the input bit, but also the
*number of times* $k$ we apply the box. Your job is to work out the
quantum nature of the box!

---

***Codercise H.1.3.*** Check the probability distribution for different input
   bits and a number of applications of the box. From these examples,
   what do you think the secret quantum rule is? To be clear, this
   is a gate you will implement in PennyLane.

<details>
<summary><i>Hint.</i></summary>
What do two boxes seem to do?
</details>
